<!--
<env-set-list></env-set-list>
import envSetList from '@/components/env/env-set-list.vue';
-->
<template>
  <div>
    <div class="search-wrap m-b-20 flex flex-space-between">
      <el-input
        v-model="searchValue"
        clearable
        class="w-320"
        placeholder="请输入配置名称/code"
        @keyup.native="value => searchData(value)"
        @clear="clearInput">
        <i
          slot="prefix"
          class="el-input__icon el-icon-search" />
      </el-input>
      <div class="search-wrap-right">
        <el-button
          type="primary"
          @click="toCreatSet">
          新建配置
        </el-button><el-radio-group
          v-model="proxyType"
          class="m-l-10"
          @change="changeType">
          <el-radio-button label="0">
            http
          </el-radio-button>
          <el-radio-button label="1">
            dubbo
          </el-radio-button>
        </el-radio-group>
      </div>
    </div>
    <div class="table-wrap">
      <el-table
        v-loading="loading"
        :data="tableData"
        style="width: 100%">
        <el-table-column
          prop="proxyName"
          label="配置名称"
          show-overflow-tooltip />
        <el-table-column
          prop="proxyCode"
          label="配置code"
          show-overflow-tooltip />
        <el-table-column
          label="描述"
          show-overflow-tooltip>
          <template slot-scope="scope">
            {{ scope.row.description }}
          </template>
        </el-table-column>
        <el-table-column
          label="创建时间"
          show-overflow-tooltip>
          <template slot-scope="scope">
            <div class="color-606266 line-18">
              {{ scope.row.createTime | timeStampToYmd }}
            </div>
            <div class="color-606266 line-18">
              {{ scope.row.createTime | timeStampToHms }}
            </div>
          </template>
        </el-table-column>
        <el-table-column
          label="操作"
          show-overflow-tooltip>
          <template slot-scope="scope">
            <el-button
              type="text"
              @click="handleShow(scope.$index, scope.row)">
              查看
            </el-button>
            <el-button
              type="text"
              @click="handleEdit(scope.$index, scope.row)">
              编辑
            </el-button>
            <el-button
              type="text"
              @click="handleDel(scope.$index, scope.row)">
              删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <div
        v-if="!!totalCount"
        class="pagination text-right m-t-14">
        <dm-pagination
          small
          :page-size="pageSize"
          :current-page="currentPage"
          layout="prev, pager, next"
          :total="totalCount"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange" />
      </div>
    </div>
  </div>
</template>
<script>
import { getRequest } from '@/api/api';
import { _debounce } from '@/assets/js/public';
import showMsg from '@/assets/js/showmsg';
import errMsg from '@/assets/js/error';
export default {
  name: 'EnvSetList',
  data() {
    return {
      proxyType: '0', // http: 0, dubbo: 1
      searchValue: '',
      loading: true,
      tableData: [
        /* {
          backendProxyId: '1',
          proxyName: '测试',
          proxyCode: '123',
          description: '234',
          proxyType: '0',
          createTime: 1564455643252
        } */
      ],
      pageSize: 20,
      currentPage: 1,
      totalCount: 0
    };
  },
  mounted() {
    const that = this;
    that.getData();
  },
  methods: {
    /**
     * @description: 新建配置
     * @author: 无尘
     */
    toCreatSet() {
      const that = this;
      that.$router.push(`/createEnvSet?proxyType=${that.proxyType}`);
    },
    /**
     * @description: 搜索
     * @author: 无尘
     */
    searchData: _debounce(function(value) {
      const that = this;
      that.currentPage == 1;
      that.getData();
    }, 500),

    /**
     * @description: 搜索清除
     * @author: 无尘
     */
    clearInput() {
      this.currentPage = 1;
      this.getData();
    },
    /**
     * @description: 切换 http dubbo
     * @author: 无尘
     */
    changeType() {
      const that = this;
      that.currentPage = 1;
      that.getData();
    },
    /**
     * @description: 分页
     * @param {Number} val
     * @author: 无尘
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.getData();
    },
    handleCurrentChange(val) {
      this.currentPage = val;
      this.getData();
    },
    /**
     * @description: 查看
     * @param {Number} index
     * @param {Object} row
     * @author: 无尘
     */
    handleShow(index, row) {
      const that = this;
      that.$router.push(`/createEnvSet?envSetFlag=show&proxyType=${row.proxyType}&backendProxyId=${row.backendProxyId}`);
    },
    /**
     * @description: 编辑
     * @param {Number} index
     * @param {Object} row
     * @author: 无尘
     */
    handleEdit(index, row) {
      const that = this;
      that.$router.push(`/createEnvSet?envSetFlag=edit&proxyType=${row.proxyType}&backendProxyId=${row.backendProxyId}`);
    },
    /**
     * @description: 删除
     * @param {Number} index
     * @param {Object} row
     * @author: 无尘
     */
    handleDel(index, row) {
      const that = this;
      that
        .$confirm('确定删除该环境?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        })
        .then(() => {
          that.postDelData(index, row);
        })
        .catch(() => {});
    },
    postDelData(index, row) {
      const that = this;
      let para = {
        backendProxyId: row.backendProxyId,
        requestProject: that.repProjectName
      };
      getRequest('/gateway-manage/delete-proxy', para)
        .then(res => {
          let resData = res.data;
          if (resData.code == '0000') {
            showMsg.showmsg('删除成功', 'success');
            that.tableData.splice(index, 1);
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * @description: 获取数据
     * @author: 无尘
     */
    getData() {
      const that = this;
      that.loading = true;
      let para = {
        search: that.searchValue,
        pageNum: that.currentPage,
        pageSize: that.pageSize,
        proxyType: that.proxyType
      };
      getRequest('/gateway-manage/page-proxy', para)
        .then(res => {
          let resData = res.data;
          that.loading = false;
          if (resData.code == '0000') {
            that.tableData = resData.result.result || [];
            that.totalCount = resData.result.totalCount;
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loading = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },

};
</script>
<style lang="less" scoped>
.w-320 {
  width: 320px;
}
.m-t-14 {
  margin-top: 14px;
}
.el-radio-group {
  display: inline-block;
  vertical-align: top;
}
</style>
